#ifndef NH_CTRL_API_H
#define NH_CTRL_API_H

#include "nh_shared_if.h"

/* Event callbacks */
typedef void (*nh_cb_init_t)(void *handle);
typedef void (*nh_cb_heartbeat_t)(void *handle);
typedef void (*nh_cb_sta_disconn_from_ap_t)(void *handle);
typedef void (*nh_cb_sta_disconn_from_soft_ap_t)(void *handle);

typedef struct {
    nh_cb_init_t                     init;
    nh_cb_heartbeat_t                heartbeat;
    nh_cb_sta_disconn_from_ap_t      sta_disconn_from_ap;
    nh_cb_sta_disconn_from_soft_ap_t sta_disconn_from_soft_ap;
} nh_ctrl_api_cb_t;

typedef struct {
    nh_shared_if_t  *shared_if;
    nh_osa_t        *osa;
    nh_ctrl_api_cb_t cb;
    void            *user_data;

    /* Private states */
} nh_ctrl_api_t;

nh_ret_t nh_ctrl_api_init(nh_ctrl_api_t *api);

#endif  // NH_CTRL_API_H
